unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Grids,
  fpSpreadsheet, fpsTypes, xlsxOOXML, xlsBiff8, fpsOpenDocument;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    SaveDialog1: TSaveDialog;
    Grid: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    FExportRow: Cardinal;
    FExportCol: Cardinal;
    procedure WriteCellDataHandler(Sender: TsWorksheet;
      ARow, ACol: Cardinal; var AData: variant; var AStyleCell: PCell);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

function RandomString(ALength: Integer): String;
var
  i: Integer;
  n: Integer;
begin
  Result := '';
  for i:=1 to ALength do begin
    n := Random(29);
    case n of
      26 : Result := Result + 'ä';
      27 : Result := Result + 'ö';
      28 : Result := Result + 'ü';
      29 : Result := Result + 'ß';
      else Result := Result + char(n + ord('a'));
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  x, y:      integer;
  ClickedOK: boolean;
  Zeilen:    string;
  t: TDateTime;
begin
  Screen.Cursor := crHourglass;
  Application.ProcessMessages;
  try
    Randomize;
    Zeilen := Edit1.Text;
    t := Now;
    ClickedOK := true;
    if ClickedOK then
    begin
      Grid.Columns.Clear;
      for x := 0 to 6 do
      begin
        Grid.Columns.Add;
      end;

      Grid.RowCount := StrToIntDef(Zeilen, 1);
      Grid.Columns[0].Title.Caption:='No.';
      Grid.Columns[1].Title.Caption:='Integer';
      Grid.Columns[2].Title.Caption:='Float';
      Grid.Columns[3].Title.Caption:='Date';
      Grid.Columns[4].Title.Caption:='DateTime';
      Grid.Columns[5].Title.Caption:='Time';
      Grid.Columns[6].Title.Caption:='String';
      Grid.RowCount := Grid.RowCount + Grid.FixedRows;
    end;

    (* Testdaten eintragen *)
    (* Zeile *)
    for x := 1 to Grid.RowCount - 1 do
    begin
      (* Spalte *)
      for y := 0 to Grid.ColCount - 1 do
      begin
        case y of
          0: (* integer *)
          begin
            Grid.Cells[y, x] := IntToStr(x);
          end;
          1: (* integer *)
          begin
            Grid.Cells[y, x] := IntToStr(Random(10000));
          end;
          2: (* Float *)
          begin
            Grid.Cells[y, x] := FormatFloat('0.00', Random(10000) * Random());
          end;
          3: (* Date *)
          begin
            Grid.Cells[y, x] := FormatDateTime('dd.mm.yyyy', Date + x);
          end;
          4: (* DateTime *)
          begin
            Grid.Cells[y, x] := FormatDateTime('dd.mm.yyyy hh:nn:ss', Date +  Random());
          end;
          5: (* Time *)
          begin
            Grid.Cells[y, x] := FormatDateTime('hh:nn:ss', time +  Random());
          end;
          6: (* String *)
          begin
            //Grid.Cells[y, x] := 'We don''t use Embarcadero ' + IntToStr(x);
            Grid.Cells[y, x] := RandomString(Random(64)+1);
          end;
        end;
      end;
    end;

    Caption := 'Füllen dauerte ' + FormatDateTime('s.zzz', Now-t) + ' sec.';
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  t: TDateTime;
begin
  Screen.Cursor := crHourglass;
  Application.ProcessMessages;
  try
    t := Now;
    Grid.SaveToCSVFile('test.csv', ';', true, false);
    Caption := 'CSV-Export dauerte ' + FormatDateTime('s.zzz', Now-t) + ' sec.';
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.WriteCellDataHandler(Sender: TsWorksheet;
  ARow, ACol: Cardinal; var AData: variant; var AStyleCell: PCell);
begin
  if ARow = 0 then
    AData := Grid.Columns[ACol].Title.Caption
  else
    AData := Grid.Cells[ACol, ARow];
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  workbook: TsWorkbook;
  worksheet: TsWorksheet;
  c: Cardinal;
  t: TDateTime;
begin
  Screen.Cursor := crHourglass;
  Application.ProcessMessages;
  t := Now;
  workbook := TsWorkbook.Create;
  try
    workbook.Options := [boVirtualMode, boBufStream];
    worksheet := workbook.AddWorksheet('Data');
    worksheet.VirtualRowCount := Grid.RowCount;
    worksheet.VirtualColCount := Grid.ColCount;
    worksheet.OnWriteCellData := @WriteCellDataHandler;
    if Sender = Button3 then
      workbook.WriteToFile('test.xlsx', sfOOXML, true)
    else
    if Sender = Button4 then
      workbook.WriteToFile('test.ods', sfOpenDocument, true)
    else
      raise Exception.Create('Da stimmt was nicht...');
  finally
    workbook.Free;
    Screen.Cursor := crDefault;
  end;
  Caption := 'Spreadsheet-Export dauerte ' + FormatDateTime('s.zzz', Now-t) + ' sec.';
end;

end.

